/*----------------------------------------------------------------------------*/
/*  vdeditor.cpp                                                              */
/*----------------------------------------------------------------------------*/
/*  copyright         : (C) 2005 by Dao Hai Lam                               */
/*                      HPT Vietnam Corporation - HPT Commerce                */
/*                      139B Pasteur, District 3,                             */
/*                      Ho Chi Minh city, VIETNAM                             */
/*  website           : http://www.hptvietnam.com.vn                          */
/*  email             : lamdh at hptvietnam dot com dot vn                    */
/*                                                                            */
/*  copyright         : (C) 2002 by Dao Hai Lam                               */
/*                      VISC Software & Security Consultant Company           */
/*                      Hall 3, Quang Trung Software City                     */
/*                      Tan Chanh Hiep Ward, District 12,                     */
/*                      Ho Chi Minh city, VIETNAM                             */
/*  website           : http://www.visc-network.com                           */
/*  email             : daohailam at yahoo dot com                            */
/*  last modify       : Sat, 27 Sep 2003 14:31:05 +0700                       */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*   This program is free software; you can redistribute it and/or modify     */
/*   it under the terms of the GNU General Public License as published by     */
/*   the Free Software Foundation; either version 2 of the License, or        */
/*   (at your option) any later version.                                      */
/*                                                                            */
/*----------------------------------------------------------------------------*/
#include "vdeditor.h"
#include "resource.h"
#include "images.h"
/*----------------------------------------------------------------------------*/
#include <qlayout.h>
#include <qtooltip.h>
#include <qpushbutton.h>
/*----------------------------------------------------------------------------*/
#define VD_FRAME_SHADOW			QFrame::Raised
#define VD_FRAME_STYLE			QFrame::WinPanel|QFrame::Raised
/*----------------------------------------------------------------------------*/
VDEditor::VDEditor( QWidget *parent ) : QFrame( parent )
{
	QGridLayout *grid = new QGridLayout( this, 0, 0, 4 );

	editor = new VDMultiLineEdit( this );
	static struct {
		char *tip;
		const char *slot;
	} b[] = {
		{ "Save",     SLOT( write() ) },
		{ "Previous", SLOT( prev() ) },
		{ "Next",     SLOT( next() ) },
	};

	for( int i=0; i<3; i++ ) {
		QPushButton *button = new QPushButton( this );
		connect( button, SIGNAL( clicked() ), b[i].slot );
		QToolTip::add( button, b[i].tip );

		button->setPixmap( vdLoadImage( b[i].tip ) );
		button->setFlat( true );
		grid->addWidget( button, 0, i );
	}

	QLabel *separator = new QLabel( this );
	separator->setFrameShape( QFrame::VLine );
	separator->setFrameShadow( QFrame::Sunken );
	grid->setColStretch( 4, 1 );
	grid->addWidget( separator, 0, 3 );
	grid->addWidget( new QLabel( this ), 0, 4 );
	grid->addMultiCellWidget( editor, 1, 1, 0, 4 );
	this->setFrameStyle( VD_FRAME_STYLE );
	this->setFrameShadow( VD_FRAME_SHADOW );
//	word->setFixedHeight( 24 );
}
/*----------------------------------------------------------------------------*/
void VDEditor::applyDefaultFont()
{
	editor->setFont( Resource::defaultFont );
}
/*----------------------------------------------------------------------------*/
void VDEditor::startEdit( VDictDB *dict, int index )
{
	current = index;
	this->dict = dict;
	char *data = "";//dict->getRawData( index );
	editor->setText( QString::fromUtf8( data ) );
	delete data;
}
/*----------------------------------------------------------------------------*/
void VDEditor::write()
{
	emit save();
}
/*----------------------------------------------------------------------------*/
void VDEditor::prev()
{
	if( current>0 && dict!=NULL )
		startEdit( dict, current - 1 );
}
/*----------------------------------------------------------------------------*/
void VDEditor::next()
{
	if( current<dict->getWordCount() && dict!=NULL )
		startEdit( dict, current + 1 );
}
/*----------------------------------------------------------------------------*/
