/*----------------------------------------------------------------------------*/
/*  vdpreferences.cpp                                                         */
/*----------------------------------------------------------------------------*/
/*  copyright         : (C) 2005 by Dao Hai Lam                               */
/*                      HPT Vietnam Corporation - HPT Commerce                */
/*                      139B Pasteur, District 3,                             */
/*                      Ho Chi Minh city, VIETNAM                             */
/*  website           : http://www.hptvietnam.com.vn                          */
/*  email             : lamdh at hptvietnam dot com dot vn                    */
/*                                                                            */
/*  copyright         : (C) 2002 by Dao Hai Lam                               */
/*                      VISC Software & Security Consultant Company           */
/*                      Hall 3, Quang Trung Software City                     */
/*                      Tan Chanh Hiep Ward, District 12,                     */
/*                      Ho Chi Minh city, VIETNAM                             */
/*  website           : http://www.visc-network.com                           */
/*  email             : daohailam at yahoo dot com                            */
/*  last modify       : Sat, 27 Sep 2003 14:31:05 +0700                       */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*   This program is free software; you can redistribute it and/or modify     */
/*   it under the terms of the GNU General Public License as published by     */
/*   the Free Software Foundation; either version 2 of the License, or        */
/*   (at your option) any later version.                                      */
/*                                                                            */
/*----------------------------------------------------------------------------*/
#include "vdconsts.h"
#include "visckey.h"
#include "vdwidgets.h"
#include "vdpreferences.h"
#include "vdcontentviewer.h"
#include "resource.h"
/*----------------------------------------------------------------------------*/
#include <qapp.h>
#include <qfiledialog.h>
#include <qcolordialog.h>
#include <qbuttongroup.h>
#include <qtextedit.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qcommonstyle.h>
#include <qwindowsstyle.h>
#include <qplatinumstyle.h>
#include <qmotifstyle.h>
#include <qmotifplusstyle.h>
#include <qcdestyle.h>
#include <qsgistyle.h>
#include <qhgroupbox.h>
#include <qvgroupbox.h>
#include <qcursor.h>
#include <qstringlist.h>
#include <qstylefactory.h>
/*----------------------------------------------------------------------------*/
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "utf.h"
/*----------------------------------------------------------------------------*/
#define	VD_FONT_CHANGED			0x01
#define	VD_STYLE_CHANGED		0x02
#define	VD_TEXTCOLOR_CHANGED	0x04
#define	VD_BACKGROUND_CHANGED	0x08
#define	VD_SPEECH_CHANGED		0x10
/*----------------------------------------------------------------------------*/
#define	vdFontChanged			(status & VD_FONT_CHANGED)
#define	vdStyleChanged			(status & VD_STYLE_CHANGED)
#define	vdTextColorChanged		(status & VD_TEXTCOLOR_CHANGED)
#define	vdBackgroundChanged		(status & VD_BACKGROUND_CHANGED)
#define vdSpeechChanged			(status & VD_SPEECH_CHANGED)
/*----------------------------------------------------------------------------*/
#define	setFontChanged()		status |= VD_FONT_CHANGED
#define	setStyleChanged()		status |= VD_STYLE_CHANGED
#define	setTextColorChanged()	status |= VD_TEXTCOLOR_CHANGED
#define	setBackgroundChanged()	status |= VD_BACKGROUND_CHANGED
#define setSpeechChanged()		status |= VD_SPEECH_CHANGED
/*----------------------------------------------------------------------------*/
char *previewData = "<BODY LINK=\"%s\">\
<FONT COLOR=\"%s\"><H3><A HREF=\"0\">[luv]</A></H3></FONT>\
<FONT COLOR=\"%s\"><H3><A HREF=\"1\">Danh từ</A></H3></FONT>\
<UL><LI>\
<FONT COLOR=\"%s\"><A HREF=\"2\">Tình yêu, mối tình, ái tình</A></FONT>\
<BR>&nbsp;\
<FONT COLOR=\"%s\"><A HREF=\"3\"><U>First</U> <U>love</U></A></FONT>\
<BR>&nbsp;\
<FONT COLOR=\"%s\"><A HREF=\"4\"><I>Mối tình đầu</I></A></FONT><BR>\
</UL></BODY>";
/*----------------------------------------------------------------------------*/
int vdLastTab = 0;
QChar previewText[] = {'T', utf_u72, ' ', utf_D9, 'i', utf_e63, 'n'};
char currentColors[5][8];
/*----------------------------------------------------------------------------*/
int defsizes[] = {
	8, 9, 10, 11, 12, 13, 14, 16,
	18,	20, 22,	24, 26, 28, 32, 36, 0
};
/*----------------------------------------------------------------------------*/
QLineEdit *speechInfo[2] = {0, 0};
/*----------------------------------------------------------------------------*/
void setDefaultPalette( const QString &name )
{
	QPalette p;
	QString n = name.lower();
	if (n == "platinum") {
		p = QPalette( QColor( 239, 239, 239 ) );
		qApp->setPalette( p, TRUE );
	}
	else if (n == "cde") {
		p = QPalette( QColor( 75, 123, 130 ) );
		p.setColor( QPalette::Active, QColorGroup::Base, QColor( 55, 77, 78 ) );
		p.setColor( QPalette::Inactive, QColorGroup::Base, QColor( 55, 77, 78 ) );
		p.setColor( QPalette::Disabled, QColorGroup::Base, QColor( 55, 77, 78 ) );
		p.setColor( QPalette::Active, QColorGroup::Highlight, Qt::white );
		p.setColor( QPalette::Active, QColorGroup::HighlightedText, QColor( 55, 77, 78 ) );
		p.setColor( QPalette::Inactive, QColorGroup::Highlight, Qt::white );
		p.setColor( QPalette::Inactive, QColorGroup::HighlightedText, QColor( 55, 77, 78 ) );
		p.setColor( QPalette::Disabled, QColorGroup::Highlight, Qt::white );
		p.setColor( QPalette::Disabled, QColorGroup::HighlightedText, QColor( 55, 77, 78 ) );
		p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::white );
		p.setColor( QPalette::Active, QColorGroup::Text, Qt::white );
		p.setColor( QPalette::Active, QColorGroup::ButtonText, Qt::white );
		p.setColor( QPalette::Inactive, QColorGroup::Foreground, Qt::white );
		p.setColor( QPalette::Inactive, QColorGroup::Text, Qt::white );
		p.setColor( QPalette::Inactive, QColorGroup::ButtonText, Qt::white );
		p.setColor( QPalette::Disabled, QColorGroup::Foreground, Qt::lightGray );
		p.setColor( QPalette::Disabled, QColorGroup::Text, Qt::lightGray );
		p.setColor( QPalette::Disabled, QColorGroup::ButtonText, Qt::lightGray );
		qApp->setPalette( p, TRUE );
	}
	else if (n.startsWith("motif")) {
		p = QPalette( QColor( 192, 192, 192 ) );
		qApp->setPalette( p, TRUE );
	}
}
/*----------------------------------------------------------------------------*/
QString getPreviewData()
{
	QString s;
	s.sprintf( previewData, currentColors[2], currentColors[0], currentColors[1],
				currentColors[2], currentColors[3], currentColors[4] );
	return QString::fromUtf8( s );
}
/*----------------------------------------------------------------------------*/
void VDPreferences::setDefaultStyle( int id )
{
	QString name = "Default";
	QStringList styles = QStyleFactory::keys();

	styles.sort();
	if (id >= styles.count()) {
		id = styles.findIndex( name );
		if (id < 0) id = 0;
	}
	else {
		name = styles[id];
	}

	qApp->setStyle( name );
	setDefaultPalette( name );

	if (qApp->mainWidget() != NULL)
		qApp->mainWidget()->setFont( Resource::defaultFont );
}
/*----------------------------------------------------------------------------*/
QColor VDPreferences::selectedColor = Qt::white;
/*----------------------------------------------------------------------------*/
VDPreferences::VDPreferences( QWidget* parent,  const char* name )
    : QDialog( parent, name, true )
{
	int i;

	resize( 410, 324 );
	setFixedSize( 410, 324 );
	setFocusPolicy( QDialog::StrongFocus );
	setCaption( tr( "Visual Dictionary setting"  ) );

	textColor = NULL;
	grid = new QGridLayout( this );
	grid->setSpacing( 8 );
	grid->setMargin( 10 );

	QPushButton* b;
	grid->addWidget( b = new QPushButton( tr( "&OK"  ), this ), 1, 0 );
	connect( b, SIGNAL( clicked() ), SLOT( accept() ) );
	grid->addWidget( applyBtn = new QPushButton( tr( "&Apply"  ), this ), 1, 1 );
	connect( applyBtn, SIGNAL( clicked() ), SLOT( apply() ) );
	grid->addWidget( b = new QPushButton( tr( "&Close"  ), this ), 1, 2 );
	connect( b, SIGNAL( clicked() ), SLOT( reject() ) );

	grid->addMultiCellWidget( tabControl = new QTabWidget( this ), 0, 0, 0, 2 );

	QWidget* tabFontInput;
	tabControl->insertTab( tabFontInput = new QWidget( tabControl ), tr( "&Font && Input" ) );
	grid = new QGridLayout( tabFontInput, 7, 1, 6, 3 );
	inputGroup = new QButtonGroup( 3, Qt::Horizontal, " Vietnamese Input Method ", tabFontInput );
	QGroupBox* fontGroup = new QHGroupBox( tr( " Font " ), tabFontInput );
	grid->addMultiCellWidget( inputGroup, 0, 1, 0, 0 );
	grid->addMultiCellWidget( fontGroup, 2, 6, 0, 0 );

	connect( inputGroup, SIGNAL( clicked( int ) ), SLOT( slotChangeInputMethod( int ) ) );
	inputGroup->insert( new QRadioButton( "Telex", inputGroup ) );
	inputGroup->insert( new QRadioButton( "Vni", inputGroup ) );
	inputGroup->insert( new QRadioButton( "Off", inputGroup ) );
	inputGroup->setButton( 2 - visckey );

	QLabel *l;
	QListBox* fontList = new QListBox( fontGroup );
	QWidget *f = new QWidget( fontGroup );
	grid = new QGridLayout( f, 3, 3, 0, 4 );
	grid->addMultiCellWidget( l = new QLabel( tr( "Size: " ), f ), 0, 0, 0, 0 );
	grid->addMultiCellWidget( fontSize = new QComboBox( true, f ), 0, 0, 1, 2 );
	grid->addMultiCellWidget( fontPreview = new QLabel( QString( previewText, 7 ), f ), 1, 2, 0, 2 );
	connect( fontList, SIGNAL( highlighted( const QString & ) ), SLOT( slotChangeFont( const QString & ) ) );
	connect( fontSize, SIGNAL( activated( int ) ), SLOT( slotChangeFontSize( int ) ) );
	connect( fontSize, SIGNAL( textChanged( const QString& ) ), SLOT( slotChangeFontSize( const QString& ) ) );
	l->setAlignment( int( QLabel::AlignRight|QLabel::AlignVCenter ) );
	fontSize->setInsertionPolicy( QComboBox::NoInsertion );
	fontSize->setAutoCompletion( true );
	fontPreview->setFrameShape( QLabel::Box );
	fontPreview->setFrameShadow( QLabel::Raised );
	fontPreview->setAlignment( int( QLabel::AlignCenter ) );
	fontPreview->setFont( Resource::defaultFont );
	fontPreview->setFixedSize( 150, 80 );
	fontList->insertStringList( Resource::dbFonts );
	fontList->setCurrentItem( fontList->findItem( Resource::defaultFont.family() ) );

	QWidget *tabTextColor = new QWidget( tabControl );
	QBoxLayout *box = new QVBoxLayout( tabTextColor, 6, 2 );
	box->addWidget( f = new QWidget( tabTextColor ) );
	box->addWidget( textColor = new VDTextBrowser( tabTextColor ) );
	box = new QHBoxLayout( f, 0, 4 );
	box->addWidget( l = new QLabel( "Background: ", f ) );
	box->addWidget( backgroundMode = new QComboBox( f ) );
	box->addWidget( chooseBtn = new QPushButton( "...", f ) );
	connect( backgroundMode, SIGNAL( activated( int ) ), SLOT( slotChangeBackground( int ) ) );
	connect( chooseBtn, SIGNAL( clicked() ), SLOT( slotChooseBackground() ) );
	l->setFixedWidth( 100 );
	l->setAlignment( int( QLabel::AlignRight|QLabel::AlignVCenter ) );
	backgroundMode->insertItem( "VnOSS" );
	backgroundMode->insertItem( "Color" );
	backgroundMode->insertItem( "Pixmap" );
	chooseBtn->setFixedSize( 23, 23 );

	for( i = 0; i < 5; i++ )
		strcpy( currentColors[i], Resource::defaultColors[i] );
	textColor->setLinkUnderline( false );
	textColor->setFont( Resource::defaultFont );
	textColor->setPaper( Resource::getBgPaper() );
	textColor->setText( getPreviewData() );
	connect( textColor, SIGNAL( getlink(const QString&) ),
				SLOT( slotChooseTextColor(const QString&) ));
	QToolTip::add( textColor, "Click item to change color" );

	tabControl->insertTab( tabTextColor, tr( "&Text color" ) );

	tabControl->insertTab( tabStyle = new QWidget( tabControl ), tr( "&Style" ) );
	box = new QVBoxLayout( tabStyle, 8, 4 );
	box->addWidget( grpStyle = new QButtonGroup( 3, Qt::Horizontal, tr( "Style"  ), tabStyle ) );
	QStringList styles = QStyleFactory::keys();
	styles.sort(); 
	for( QStringList::Iterator it = styles.begin(); it != styles.end(); ++it )
		grpStyle->insert( new QRadioButton( *it, grpStyle ) );
	grpStyle->setButton( Resource::defaultStyle );
	connect( grpStyle, SIGNAL( clicked( int ) ), SLOT( slotChangeStyle( int ) ) );

	selectedPixmap = "";
	int bgMode = Resource::getBgMode();
	switch( bgMode ) {
		case 1:
			selectedColor = QColor( &Resource::defaultBackground[1] );
			if( !selectedColor.isValid() )
				selectedColor = Qt::white;
			break;
		case 2:
			selectedPixmap = QString( &Resource::defaultBackground[1] );
			break;
	}
	backgroundMode->setCurrentItem( bgMode );
	slotChangeBackground( bgMode );

	QWidget *tabSpeech = new QWidget( tabControl );
	QCheckBox *enaSpeech = new QCheckBox( "Enable Festival support", tabSpeech );
	QButtonGroup *optGroup = new QButtonGroup( 4, Qt::Vertical, " Using: ", tabSpeech );
	QRadioButton *selCmd = new QRadioButton( "Command:", optGroup );
	QLineEdit *cmdSpeech = speechInfo[0] = new QLineEdit( "festival", optGroup );
	QRadioButton *selSrv = new QRadioButton( "Server:", optGroup );
	QLineEdit *srvSpeech = speechInfo[1] = new QLineEdit( "127.0.0.1:1314", optGroup );
	grid = new QGridLayout( tabSpeech, 7, 1, 6, 3 );
	grid->addMultiCellWidget( enaSpeech, 0, 0, 0, 0 );
	grid->addMultiCellWidget( speechGroup = optGroup, 1, 1, 0, 0 );
	tabControl->insertTab( tabSpeech, "S&peech" );

	enaSpeech->setChecked( Resource::speechEnabled );
	speechGroup->setEnabled( Resource::speechEnabled );
	speechInfo[Resource::speechMode]->setText( Resource::speechInfo );
	if ( Resource::speechEnabled )
		speechInfo[1 - Resource::speechMode]->setEnabled( false );
	speechGroup->setButton( Resource::speechMode );

	connect( enaSpeech, SIGNAL( clicked() ), SLOT( slotChangeSpeechStatus() ) );
	connect( selCmd, SIGNAL( clicked() ), SLOT( slotChangeSpeechMode() ) );
	connect( selSrv, SIGNAL( clicked() ), SLOT( slotChangeSpeechMode() ) );
	connect( cmdSpeech, SIGNAL( textChanged( const QString& ) ),
						SLOT( slotChangeSpeechInfo( const QString& ) ) );
	connect( srvSpeech, SIGNAL( textChanged( const QString& ) ),
						SLOT( slotChangeSpeechInfo( const QString& ) ) );

	tabControl->setCurrentPage( vdLastTab );
	applyBtn->setEnabled( false );
	status = 0;
}
/*----------------------------------------------------------------------------*/
VDPreferences::~VDPreferences()
{
	vdLastTab = tabControl->currentPageIndex();
}
/*----------------------------------------------------------------------------*/
void VDPreferences::execute()
{
	if( exec()==Accepted )
		apply();
}
/*----------------------------------------------------------------------------*/
void VDPreferences::apply()
{
	if( vdFontChanged ) {
		Resource::defaultFont = fontPreview->font();
		qApp->mainWidget()->setFont( Resource::defaultFont );
	}

	if( vdStyleChanged )
		setDefaultStyle( Resource::defaultStyle = grpStyle->id( grpStyle->selected() ) );

	if( vdBackgroundChanged ) {
		Resource::setBackground( backgroundMode->currentItem(), selectedColor, selectedPixmap );
		contents->setPaper( Resource::getBgPaper() );
	}

	if( vdTextColorChanged )
		for( int i = 0; i < 5; i++ )
			strncpy( Resource::defaultColors[i], currentColors[i], 7 );

	if( vdFontChanged || vdTextColorChanged )
		contents->applyDefaultColor();

	if( vdSpeechChanged )
		viewer->resetSpeech();

	applyBtn->setEnabled( false );

	visckey = 2 - inputGroup->id( inputGroup->selected() );
	status = 0;
}
/*----------------------------------------------------------------------------*/
void VDPreferences::slotChangeInputMethod( int )
{
	applyBtn->setEnabled( true );
}
/*----------------------------------------------------------------------------*/
void VDPreferences::slotChangeFont( const QString &name )
{
	int idx, fs;

	if( !fontSize->count() )
		fs = Resource::defaultFont.pointSize();
	else {
		fs = fontSize->currentText().toInt();
		fontSize->clear();
	}

	QValueList<int> p = db.smoothSizes( name, "Normal", "iso10646-1" );
	if( !p.count() )
		p = db.pointSizes( name, "Normal", "iso10646-1" );
	if( !p.count() ) {
		for( uint n=0; defsizes[n]; n++ )
			p.append(defsizes[n]);
	}
	for( uint i=0; i<p.count(); i++ )
		fontSize->insertItem( QString( "%1" ).arg( p[i] ) );
	if( (idx=p.findIndex( fs ))<0 )
		fontSize->setEditText( QString( "%1" ).arg( fs ) );
	else
		fontSize->setCurrentItem( idx );

	applyBtn->setEnabled( true );
#if QT_VERSION >= 300
	fontPreview->setFont( QFont( name, fs, QFont::Normal, false ) );
#else
	fontPreview->setFont( QFont( name, fs, QFont::Normal, false, QFont::Unicode ) );
#endif
	if( textColor ) textColor->setFont( fontPreview->font() );
	setFontChanged();
}
/*----------------------------------------------------------------------------*/
void VDPreferences::slotChangeBackground( int id )
{
	QBrush p;
	switch( id ) {
		case 0:
			p.setPixmap( Resource::VnOSSBackground );
			textColor->setPaper( p );
			break;
		case 1:
			if( !selectedColor.isValid() )
				slotChooseBackground();
			else {
				p.setColor( selectedColor );
				p.setStyle( Qt::SolidPattern );
				textColor->setPaper( p );
			}
			break;
		case 2:
			if( !selectedPixmap.isNull() && !selectedPixmap.isEmpty() ) {
				p.setPixmap( QPixmap( selectedPixmap ) );
				textColor->setPaper( p );
			}
			else {
				slotChooseBackground();
			}
			break;
	}
	chooseBtn->setEnabled( id > 0 );
	applyBtn->setEnabled( true );
	setBackgroundChanged();
}
/*----------------------------------------------------------------------------*/
void VDPreferences::slotChooseBackground()
{
	QBrush paper;
	switch( backgroundMode->currentItem() ) {
		case 1: {
			QColor c = QColorDialog::getColor( selectedColor, this );
			if( c.isValid() && c!=selectedColor ) {
				paper.setColor( selectedColor = c );
				paper.setStyle( Qt::SolidPattern );
				textColor->setPaper( paper );
			}
			break;
		}
		case 2: {
			QString s;
			s = QFileDialog::getOpenFileName( selectedPixmap,
								"Images (*.png *.xpm *.jpg)", this );
			if( !s.isNull() ) {
				QPixmap p( s );
				if( !p.isNull() ) {
					selectedPixmap = s;
					paper.setPixmap( p );
					textColor->setPaper( paper );
				}
			}
			break;
		}
	}
	applyBtn->setEnabled( true );
	setBackgroundChanged();
}
/*----------------------------------------------------------------------------*/
void VDPreferences::slotChangeFontSize( int idx )
{
	QFont f = fontPreview->font();
	f.setPointSize( fontSize->text( idx ).toInt() );
	applyBtn->setEnabled( true );
	fontPreview->setFont( f );
	if( textColor ) textColor->setFont( f );
	setFontChanged();
}
/*----------------------------------------------------------------------------*/
void VDPreferences::slotChangeFontSize( const QString& s )
{
	int size = s.toInt();

	if( size >= 8 && size <= 36 ) {
		QFont f = fontPreview->font();
		f.setPointSize( size );
		applyBtn->setEnabled( true );
		fontPreview->setFont( f );
		if( textColor ) textColor->setFont( f );
		setFontChanged();
	}
}
/*----------------------------------------------------------------------------*/
void VDPreferences::slotChangeStyle( int id )
{
	applyBtn->setEnabled( true );
	setStyleChanged();
}
/*----------------------------------------------------------------------------*/
void VDPreferences::slotChooseTextColor( const QString &idx )
{
	int n = idx.toInt();
	QColor c( currentColors[n] );
	c = QColorDialog::getColor( c, this );
	if( c.isValid() ) {
		strncpy( currentColors[n], c.name(), 7 );
		textColor->setText( getPreviewData() );
		setTextColorChanged();
		applyBtn->setEnabled( true );
	}
}
/*----------------------------------------------------------------------------*/
void VDPreferences::slotChangeSpeechStatus()
{
	int id = Resource::speechMode;
	QCheckBox *cb = (QCheckBox *)sender();
	speechGroup->setEnabled( Resource::speechEnabled = cb->isChecked() );
	speechGroup->setButton( id );
	speechInfo[1 - id]->setEnabled( false );
	speechInfo[id]->setEnabled( true );
	applyBtn->setEnabled( true );
	setSpeechChanged();
}
/*----------------------------------------------------------------------------*/
void VDPreferences::slotChangeSpeechMode()
{
	int id = Resource::speechMode = speechGroup->id( speechGroup->selected() );
	Resource::speechInfo = speechInfo[id]->text();
	speechInfo[1 - id]->setEnabled( false );
	speechInfo[id]->setEnabled( true );
	speechInfo[id]->setFocus();

	applyBtn->setEnabled( true );
	setSpeechChanged();
}
/*----------------------------------------------------------------------------*/
void VDPreferences::slotChangeSpeechInfo( const QString& text )
{
	Resource::speechInfo = text;
	applyBtn->setEnabled( true );
	setSpeechChanged();
}
/*----------------------------------------------------------------------------*/
